(function ($) {

  // Fieldset summariy handlers.
  if ($.fn.drupalSetSummary) {
    Drupal.behaviors.node_registration_fieldsetSummary = {
      attach: function(context) {

        // Node type form.
        $('#node-type-form #edit-node-level-blocks', context).drupalSetSummary(function(context) {
          var enabled = $('#edit-node-level-blocks-node-level-blocks-enabled:checked', context).length;
          if (enabled) {
            var regions = $('#edit-node-level-blocks-settings-node-level-blocks-regions').val() || [],
                modules = $('#edit-node-level-blocks-settings-node-level-blocks-modules').val() || [];
            return Drupal.t('Enabled, !regions regions, !modules modules', {"!regions": regions.length, "!modules": modules.length});
          }

          return Drupal.t('Disabled');
        });

        // Node form.
        $('.node-form #edit-node-level-blocks', context).drupalSetSummary(function(context) {
          var blocks = $('.block-region-select').filter(function(i, el) {
            var region = $(el).val();
            return region != '-1';
          });
          return Drupal.t('!blocks blocks placed', {"!blocks": blocks.length});
        });

      }
    };
  }

  // onDomReady: override Drupal.tableDrag.prototype.row.prototype.isValidSwap to add swap-validation.
  if (Drupal.tableDrag) {
    var _isValidSwap = Drupal.tableDrag.prototype.row.prototype.isValidSwap;
    Drupal.tableDrag.prototype.row.prototype.isValidSwap = function(tr) {
      // Do standard tableDrag validation.
      var valid = _isValidSwap.apply(this, arguments);
      if (!valid) {
        return false;
      }

      // One of us?
      var $select = $('.form-select', this.element),
          loner = $select[0].options.length <= 1;
      if (loner) {
        // Can't swap with non-draggables, since that would mean a boundary.
        if (!$(tr).is('.draggable')) {
          return false;
        }

        // Can't skip over any rows, since that might be a boundary.
        var diff = tr.rowIndex - this.element.rowIndex;
        if (Math.abs(diff) > 1) {
          return false;
        }
      }

      return true;
    };

    // Add swap handler to trigger fieldset summary update, because tableDrag doesn't do that.
    var _drop = Drupal.tableDrag.prototype.dropRow;
    Drupal.tableDrag.prototype.dropRow = function(event, self) {
      var retval = _drop.call(this, event, self);
      $('.node-form #edit-node-level-blocks').trigger('summaryUpdated');
      return retval;
    };
  }

})(jQuery);
